// Action script...

function type_init()
{
    LOG_BTYPE[LOG_BTYPE_GDI_BARRACKS] = new Array("G", "Barracks", bg_pic_mc.gdi_barracks_mc);
    LOG_BTYPE[LOG_BTYPE_GDI_REF] = new Array("G", "Refinery", bg_pic_mc.gdi_ref_mc);
    LOG_BTYPE[LOG_BTYPE_GDI_AGT] = new Array("G", "AGT", bg_pic_mc.gdi_agt_mc);
    LOG_BTYPE[LOG_BTYPE_GDI_WF] = new Array("G", "War Factory", bg_pic_mc.gdi_wf_mc);
    LOG_BTYPE[LOG_BTYPE_GDI_PP] = new Array("G", "Power Plant", bg_pic_mc.gdi_pp_mc);
    LOG_BTYPE[LOG_BTYPE_GDI_GUN_CEILING] = new Array("G", "Ceiling Gun", bg_pic_mc.gdi_agt_mc);
    LOG_BTYPE[LOG_BTYPE_GDI_GUN_AGT] = new Array("G", "AGT Gun", bg_pic_mc.gdi_agt_mc);
    LOG_BTYPE[LOG_BTYPE_NOD_HAND] = new Array("N", "Hand of Nod", bg_pic_mc.nod_hand_mc);
    LOG_BTYPE[LOG_BTYPE_NOD_REF] = new Array("N", "Refinery", bg_pic_mc.nod_ref_mc);
    LOG_BTYPE[LOG_BTYPE_NOD_OBELISK] = new Array("N", "Obelisk", bg_pic_mc.nod_obelisk_mc);
    LOG_BTYPE[LOG_BTYPE_NOD_STRIP] = new Array("N", "Airstrip", bg_pic_mc.nod_strip_mc);
    LOG_BTYPE[LOG_BTYPE_NOD_PP] = new Array("N", "Power Plant", bg_pic_mc.nod_pp_mc);
    LOG_BTYPE[LOG_BTYPE_NOD_HELIPAD] = new Array("N", "Helipad", undefined);
    LOG_BTYPE[LOG_BTYPE_NOD_SAMSITE] = new Array("N", "Sam Site", undefined);
    LOG_BTYPE[LOG_BTYPE_NOD_TURRET] = new Array("N", "Turret", bg_pic_mc.nod_turret_mc);
    LOG_BTYPE[LOG_BTYPE_NOD_GUN_TURRET] = new Array("N", "Turret Gun", bg_pic_mc.nod_turret_mc);
    LOG_BTYPE[LOG_BTYPE_NOD_GUN_TURRETI] = new Array("N", "Turret Gun Improved", bg_pic_mc.nod_turret_mc);
    LOG_BTYPE[LOG_BTYPE_NOD_GUN_OBELISK] = new Array("N", "Obelisk Gun", bg_pic_mc.nod_obelisk_mc);
    LOG_VTYPE[LOG_VTYPE_GDI_APC] = new Array("G", "APC", "gdi_apc");
    LOG_VTYPE[LOG_VTYPE_GDI_HARVY] = new Array("G", "Harvester", "gdi_harvester");
    LOG_VTYPE[LOG_VTYPE_GDI_HUMM] = new Array("G", "Humm-vee", "gdi_hummvee");
    LOG_VTYPE[LOG_VTYPE_GDI_MAMMOTH] = new Array("G", "Mammoth Tank", "gdi_mammoth");
    LOG_VTYPE[LOG_VTYPE_GDI_MEDIUM] = new Array("G", "Medium Tank", "gdi_medium");
    LOG_VTYPE[LOG_VTYPE_GDI_MRLS] = new Array("G", "MRLS", "gdi_mrls");
    LOG_VTYPE[LOG_VTYPE_GDI_ORCA] = new Array("G", "Orca", "gdi_orca");
    LOG_VTYPE[LOG_VTYPE_NOD_APC] = new Array("N", "APC", "nod_apc");
    LOG_VTYPE[LOG_VTYPE_NOD_ARTI] = new Array("N", "Artillery", "nod_artillery");
    LOG_VTYPE[LOG_VTYPE_NOD_BUGGY] = new Array("N", "Buggy", "nod_buggy");
    LOG_VTYPE[LOG_VTYPE_NOD_FLAME] = new Array("N", "Flame Tank", "nod_flametank");
    LOG_VTYPE[LOG_VTYPE_NOD_HARVY] = new Array("N", "Harvester", "nod_harvester");
    LOG_VTYPE[LOG_VTYPE_NOD_LIGHT] = new Array("N", "Light Tank", "nod_light");
    LOG_VTYPE[LOG_VTYPE_NOD_STEALTH] = new Array("N", "Stealth Tank", "nod_stealth");
    LOG_VTYPE[LOG_VTYPE_NOD_APACHE] = new Array("N", "Apache", "nod_apache");
    LOG_STYPE[LOG_STYPE_GDI_MINIGUNNER] = new Array("G", "Minigunner");
    LOG_STYPE[LOG_STYPE_GDI_SHOTGUNNER] = new Array("G", "Shotgun Trooper");
    LOG_STYPE[LOG_STYPE_GDI_GRENADIER] = new Array("G", "Grenadier");
    LOG_STYPE[LOG_STYPE_GDI_ENGINEER] = new Array("G", "Engineer");
    LOG_STYPE[LOG_STYPE_GDI_OFFICER] = new Array("G", "Officer");
    LOG_STYPE[LOG_STYPE_GDI_ROCKET_SOLDIER] = new Array("G", "Rocket Soldier");
    LOG_STYPE[LOG_STYPE_GDI_SYDNEY] = new Array("G", "Sydney");
    LOG_STYPE[LOG_STYPE_GDI_DEADEYE] = new Array("G", "Deadeye");
    LOG_STYPE[LOG_STYPE_GDI_GUNNER] = new Array("G", "Gunner");
    LOG_STYPE[LOG_STYPE_GDI_PATCH] = new Array("G", "Patch");
    LOG_STYPE[LOG_STYPE_GDI_HAVOC] = new Array("G", "Havoc");
    LOG_STYPE[LOG_STYPE_GDI_PROTO_SYDNEY] = new Array("G", "Prototype Sydney");
    LOG_STYPE[LOG_STYPE_GDI_MOBIUS] = new Array("G", "Mobius");
    LOG_STYPE[LOG_STYPE_GDI_HOTWIRE] = new Array("G", "Hotwire");
    LOG_STYPE[LOG_STYPE_NOD_MINIGUNNER] = new Array("N", "Minigunner");
    LOG_STYPE[LOG_STYPE_NOD_SHOTGUNNER] = new Array("N", "Shotgun Trooper");
    LOG_STYPE[LOG_STYPE_NOD_FLAMETHROWER] = new Array("N", "Flamethower");
    LOG_STYPE[LOG_STYPE_NOD_ENGINEER] = new Array("N", "Engineer");
    LOG_STYPE[LOG_STYPE_NOD_OFFICER] = new Array("N", "Officer");
    LOG_STYPE[LOG_STYPE_NOD_ROCKET_SOLDIER] = new Array("N", "Rocket Soldier");
    LOG_STYPE[LOG_STYPE_NOD_CHEM_WARRIOR] = new Array("N", "Chem Warrior");
    LOG_STYPE[LOG_STYPE_NOD_BLACKHAND_SNIPER] = new Array("N", "Blackhand Sniper");
    LOG_STYPE[LOG_STYPE_NOD_LASER_CHAINGUNNER] = new Array("N", "Laser Chaingun");
    LOG_STYPE[LOG_STYPE_NOD_SBH] = new Array("N", "Stealth Black Hand");
    LOG_STYPE[LOG_STYPE_NOD_SAKURA] = new Array("N", "Sakura");
    LOG_STYPE[LOG_STYPE_NOD_RAVESHAW] = new Array("N", "Raveshaw");
    LOG_STYPE[LOG_STYPE_NOD_MENDOZA] = new Array("N", "Mendoza");
    LOG_STYPE[LOG_STYPE_NOD_TECHNICAN] = new Array("N", "Technican");
    LOG_OTYPE[LOG_OTYPE_TIMED] = "Timed C4";
    LOG_OTYPE[LOG_OTYPE_REMOTE] = "Remote C4";
    LOG_OTYPE[LOG_OTYPE_PROXY] = "Proximity Mine";
    LOG_OTYPE[LOG_OTYPE_ION] = "Ion Canon Beacon";
    LOG_OTYPE[LOG_OTYPE_NUKE] = "Nuclear Strike Beacon";
} // End of the function
function show_time(str)
{
    logs_mc.add_log_line(-1, str + ": " + (getTimer() - last_time) / 1000 + " secs\n");
    last_time = getTimer();
} // End of the function
function get_time_of_sec(sec)
{
    return (sec);
} // End of the function
function do_explosion(x, y, width, exptype)
{
    exp_counter = (exp_counter + 1) % MAX_EXP_NUM;
    switch (exptype)
    {
        case 1:
        {
            exp = attachMovie("ion_ring", "exp_" + exp_counter + "_mc", EXPLOSION_DEPTH + exp_counter);
            break;
        } 
        case 2:
        {
            exp = attachMovie("nuke", "exp_" + exp_counter + "_mc", EXPLOSION_DEPTH + exp_counter);
            break;
        } 
        case 0:
        default:
        {
            exp = attachMovie("explosion1", "exp_" + exp_counter + "_mc", EXPLOSION_DEPTH + exp_counter);
            break;
        } 
    } // End of switch
    exp._x = x;
    exp._y = y;
    exp._height = width / exp._width * exp._height;
    exp._width = width;
} // End of the function
function bind_player(obj)
{
    if (players[obj.player_name] == undefined)
    {
        if (obj.gdi)
        {
            team = "GDI";
        }
        else
        {
            team = "Nod";
        } // end else if
        logs_mc.add_log_line(_root.ri, obj.player_name + " joined " + team + ".\n");
        new_player = new Object();
        new_player.player_obj = obj;
        new_player.frags = 0;
        new_player.fragged = 0;
        new_player.score = 0;
        players[obj.player_name] = new_player;
    } // end if
    obj.name_tf.text = obj.player_name;
    if (players[obj.player_name].player_obj != obj)
    {
        old_obj = players[obj.player_name].player_obj;
        players[obj.player_name].objtype_history.push(old_obj.objtype);
        players[obj.player_name].player_obj = obj;
        obj.track_me = old_obj.track_me;
    } // end if
    if (playspeed > 0)
    {
        type = obj.objtype;
    }
    else
    {
        type = players[obj.player_name].objtype_history.pop();
    } // end else if
    obj.descr_tf.text = LOG_STYPE[type][1];
    if (obj.gdi)
    {
        team_list_gdi_mc.add_player(obj);
    }
    else
    {
        team_list_nod_mc.add_player(obj);
    } // end else if
} // End of the function
function unbind_player(obj)
{
    if (obj.gdi)
    {
        team_list_gdi_mc.del_player(obj);
    }
    else
    {
        team_list_nod_mc.del_player(obj);
    } // end else if
} // End of the function
function enter_vehicle(vehicle, player)
{
    player.vehicle = vehicle;
    player._visible = false;
    vehicle.gdi = player.gdi;
    if (vehicle.driver == false)
    {
        vehicle.driver = player;
    }
    else
    {
        vehicle.passengers.push(player);
    } // end else if
    if (player.track_me)
    {
        vehicle.pass = vehicle.pass + 1;
    } // end if
    if (vehicle.objtype == LOG_VTYPE_NOD_STEALTH)
    {
        vehicle.last_shot.push(_root.ri);
    } // end if
    vehicle.update_vdescr();
} // End of the function
function leave_vehicle(vehicle, player)
{
    player.teleport(vehicle._x, vehicle._y);
    player._visible = true;
    player.vehicle = false;
    if (vehicle.driver == player)
    {
        vehicle.driver = false;
    }
    else
    {
        for (p = 0; p < vehicle.passengers.length; p++)
        {
            if (vehicle.passengers[p] == player)
            {
                break;
            } // end if
        } // end of for
        vehicle.passengers.splice(p, 1);
    } // end else if
    if (player.track_me)
    {
        vehicle.pass = vehicle.pass - 1;
    } // end if
    if (vehicle.objtype == LOG_VTYPE_NOD_STEALTH)
    {
        vehicle.last_shot.push(_root.ri);
    } // end if
    vehicle.update_vdescr();
} // End of the function
function do_damage(attacker_id, victim_id, damage)
{
    var _loc1 = objects[attacker_id];
    var _loc2 = objects[victim_id];
    var _loc3 = false;
    if (_loc1 == undefined || _loc1._y == undefined || _loc1._y < 10)
    {
        trace ("A! " + get_time_of_sec(i) + " v:\'" + id + "\' a:\'" + attacker_id + "\' y=" + _loc1._y);
        _loc3 = true;
    } // end if
    if (_loc2 == undefined || _loc2._y == undefined || _loc2._y < 10)
    {
        trace ("V! " + get_time_of_sec(i) + " v:\'" + id + "\' a:\'" + attacker_id + "\' y=" + obj._y);
        _loc3 = true;
    } // end if
    if (!_loc3)
    {
        shots_mc.show_shot(_loc1, _loc2, damage);
    } // end if
} // End of the function
function play_next_sec()
{
    show_play_time();
    if (playspeed > 0)
    {
        if (_root.ri == _root.gamedata.timeline.length)
        {
            set_playspeed(0);
            return;
        } // end if
    }
    else if (playspeed < 0)
    {
        if (_root.ri <= 0)
        {
            set_playspeed(0);
            return;
        } // end if
    }
    else
    {
        trace ("how did i get here ?!");
        return;
    } // end else if
    for (i = gamedata.timeline[_root.ri]; i < gamedata.timeline[_root.ri + 1] - 1; i++)
    {
        row = gamedata.rows[i].split(",");
        action = row[0];
        id = row[1];
        obj = objects[id];
        if (action == LOG_ACT_CREATED)
        {
            category = row[2];
            type = row[3];
            x = Number(row[5]);
            y = Number(row[4]);
            max_hp = Number(row[8]);
            max_shield = Number(row[9]);
            if (category != LOG_CAT_BUILDING)
            {
                obj._x = x;
                obj._y = y;
            } // end if
            if (category == LOG_CAT_SOLDIER)
            {
                if (playspeed >= 0)
                {
                    obj.thing_init(id, category, type, max_hp, max_shield);
                    bind_player(obj);
                    obj.vehicle = false;
                }
                else
                {
                    unbind_player(obj);
                } // end else if
                obj.mytext.descr_tf.text = LOG_STYPE[obj.objtype][1];
            }
            else if (category == LOG_CAT_VEHICLE)
            {
                obj.thing_init(id, category, type, max_hp, max_shield);
            }
            else if (category == LOG_CAT_BUILDING)
            {
                if (type == LOG_BTYPE_GDI_GUN_CEILING || type == LOG_BTYPE_GDI_AGT || type == LOG_BTYPE_GDI_GUN_AGT || type == LOG_BTYPE_NOD_GUN_OBELISK)
                {
                    max_hp = 500;
                }
                else if (type == LOG_BTYPE_NOD_TURRET || type == LOG_BTYPE_NOD_GUN_TURRET)
                {
                    max_hp = 300;
                } // end else if
                max_shield = 0;
            }
            else if (category == LOG_CAT_OBJECT)
            {
                if (type == LOG_OTYPE_PROXY)
                {
                    if (playspeed > 0)
                    {
                        mines_mc.create_proxy(obj);
                    }
                    else
                    {
                        mines_mc.destroy_proxy(obj);
                    } // end else if
                }
                else if (type == LOG_OTYPE_TIMED || type == LOG_OTYPE_ION || type == LOG_OTYPE_NUKE)
                {
                    obj.thing_init(id, category, type, max_hp, max_shield);
                    obj._x = x;
                    obj._y = y;
                    obj._visible = playspeed > 0;
                } // end else if
            }
            else if (category == LOG_CAT_CRATE)
            {
            } // end else if
            if (category != LOG_CAT_OBJECT)
            {
                obj.sel_mc.hp_mc.set_hp_max(max_hp + max_shield);
                obj.sel_mc.hp_mc.set_hp(max_hp + max_shield);
                obj._visible = category != LOG_CAT_VEHICLE;
            } // end if
            continue;
        } // end if
        if (action == LOG_ACT_POS)
        {
            x = Number(row[3]);
            y = Number(row[2]);
            if (obj._visible == false && (obj.vehicle == undefined || !obj.vehicle))
            {
                obj.teleport(x, y);
                obj._visible = true;
            }
            else
            {
                obj.move_to(x, y);
            } // end else if
            if (row[5] != undefined)
            {
                var _loc2 = Number(row[5]) + Number(row[6]);
                if (obj.vehicle == false)
                {
                    obj.sel_mc.hp_mc.set_hp(_loc2);
                }
                else
                {
                    obj.vehicle.sel_mc.hp_mc.set_hp(_loc2);
                } // end if
            } // end else if
            continue;
        } // end if
        if (action == LOG_ACT_DAMAGED)
        {
            if (gamedata.logversion > 2.020000E+000)
            {
            } // end if
            attacker_id = row[2];
            damage = row[3];
            do_damage(attacker_id, id, damage);
            if (obj.category == LOG_CAT_BUILDING)
            {
                obj.sel_mc.hp_mc.set_hp(Number(row[4]));
            } // end if
            continue;
        } // end if
        if (action == LOG_ACT_KILLED)
        {
            killer_id = row[2];
            killer = objects[killer_id];
            inc = 1;
            if (playspeed < 0)
            {
                inc = -1;
            } // end if
            if (obj.category == LOG_CAT_BUILDING)
            {
                btype = LOG_BTYPE[obj.objtype][1];
                if (obj.gdi)
                {
                    logs_mc.add_log_line(_root.ri, "GDI " + btype + " destroyed by " + killer.player_name + ".\n");
                }
                else
                {
                    logs_mc.add_log_line(_root.ri, "NoD " + btype + " destroyed by " + killer.player_name + ".\n");
                } // end else if
                if (playspeed > 0)
                {
                    obj.body_mc._alpha = 35;
                }
                else
                {
                    obj.body_mc._alpha = 0;
                } // end else if
            }
            else if (obj.category == LOG_CAT_SOLDIER)
            {
                if (obj.gdi)
                {
                    team_list_gdi_mc.change_fragged(obj, inc);
                }
                else
                {
                    team_list_nod_mc.change_fragged(obj, inc);
                } // end else if
                if (killer.category == LOG_CAT_SOLDIER)
                {
                    if (killer.gdi)
                    {
                        team_list_gdi_mc.change_frags(killer, inc);
                    }
                    else
                    {
                        team_list_nod_mc.change_frags(killer, inc);
                    } // end else if
                    if (id == killer_id)
                    {
                        logs_mc.add_log_line(_root.ri, obj.player_name + " comited suicide.\n");
                    }
                    else
                    {
                        logs_mc.add_log_line(_root.ri, obj.player_name + " was killed by " + killer.player_name + ".\n");
                    } // end else if
                }
                else
                {
                    if (killer.category == LOG_CAT_BUILDING)
                    {
                        btype = LOG_BTYPE[killer.objtype][1];
                    }
                    else if (killer.category == LOG_CAT_OBJECT)
                    {
                        btype = LOG_OTYPE[killer.objtype];
                    }
                    else
                    {
                        btype = "something strange";
                    } // end else if
                    logs_mc.add_log_line(_root.ri, obj.player_name + " was killed by " + btype + ".\n");
                } // end else if
            }
            else if (obj.category == LOG_CAT_VEHICLE)
            {
                if (killer.category == LOG_CAT_SOLDIER)
                {
                    logs_mc.add_log_line(_root.ri, LOG_VTYPE[obj.objtype][1] + " destroyed by " + killer.player_name + ".\n");
                }
                else
                {
                    btype = LOG_BTYPE[killer.objtype][1];
                    logs_mc.add_log_line(_root.ri, LOG_VTYPE[obj.objtype][1] + " destroyed by " + btype + ".\n");
                } // end else if
                if (obj.driver)
                {
                    if (playspeed > 0)
                    {
                        obj.driver.teleport(obj._x, obj._y);
                        obj.driver.vehicle = false;
                    }
                    else
                    {
                        if (obj.driver.track_me)
                        {
                            obj.pass = obj.pass + 1;
                        } // end if
                        obj.driver.vehicle = obj;
                    } // end else if
                    obj.driver._visible = playspeed > 0;
                } // end if
                for (p = 0; p < obj.passengers.length; p++)
                {
                    if (playspeed > 0)
                    {
                        obj.passengers[p].teleport(obj._x, obj._y);
                        obj.passengers[p].vehicle = false;
                    }
                    else
                    {
                        if (obj.passengers[p].track_me)
                        {
                            obj.pass = obj.pass + 1;
                        } // end if
                        obj.passengers[p].vehicle = obj;
                    } // end else if
                    obj.passengers[p]._visible = playspeed > 0;
                } // end of for
            }
            else if (obj.category == LOG_CAT_OBJECT)
            {
                logs_mc.add_log_line(_root.ri, LOG_OTYPE[obj.objtype] + " disarmed by " + killer.player_name + ".\n");
            } // end else if
            obj.killed = playspeed > 0;
            continue;
        } // end if
        if (action == LOG_ACT_DESTROYED)
        {
            if (obj.category == LOG_CAT_VEHICLE)
            {
            }
            else if (obj.category == LOG_CAT_SOLDIER)
            {
                if (playspeed < 0)
                {
                    bind_player(obj);
                }
                else
                {
                    unbind_player(obj);
                } // end else if
            }
            else if (obj.category == LOG_CAT_OBJECT)
            {
                if (obj.objtype == LOG_OTYPE_PROXY)
                {
                    if (playspeed > 0)
                    {
                        mines_mc.destroy_proxy(obj);
                    }
                    else
                    {
                        mines_mc.create_proxy(obj);
                    } // end else if
                } // end else if
            } // end else if
            obj.destroyed = playspeed > 0;
            continue;
        } // end if
        if (action == LOG_ACT_ENTER)
        {
            if (playspeed > 0)
            {
                enter_vehicle(obj, objects[row[2]]);
            }
            else
            {
                leave_vehicle(obj, objects[row[2]]);
            } // end else if
            continue;
        } // end if
        if (action == LOG_ACT_EXIT)
        {
            if (playspeed > 0)
            {
                leave_vehicle(obj, objects[row[2]]);
            }
            else
            {
                enter_vehicle(obj, objects[row[2]]);
            } // end else if
            continue;
        } // end if
        if (action == LOG_ACT_CHAT)
        {
            if (row[2] == "T")
            {
                chat_type = obj.gdi ? ("[GDI]") : (chat_type = "[Nod]");
            }
            else
            {
                chat_type = "[ALL]";
            } // end else if
            logs_mc.add_log_line(_root.ri, chat_type + " " + obj.player_name + ": " + row[3] + "\n");
            chats_mc.add_chat_line(_root.ri, obj, row[2], row[3]);
        } // end if
    } // end of for
    if (last_log_sec < ri)
    {
        last_log_sec = ri;
    } // end if
    chats_mc.update_chat();
    if (playspeed > 0)
    {
        ++_root.ri;
    }
    else
    {
        --_root.ri;
    } // end else if
} // End of the function
function secs_to_time_str(val)
{
    hours = Math.floor(val / 3600);
    mins = Math.floor((val - hours * 3600) / 60);
    secs = val - hours * 3600 - mins * 60;
    if (hours < 10)
    {
        hours = "0" + hours;
    } // end if
    if (mins < 10)
    {
        mins = "0" + mins;
    } // end if
    if (secs < 10)
    {
        secs = "0" + secs;
    } // end if
    return (hours + ":" + mins + ":" + secs);
} // End of the function
function show_play_time()
{
    time_tf.text = secs_to_time_str(_root.ri);
} // End of the function
function set_playspeed(speed)
{
    switch (Math.abs(speed))
    {
        case 0:
        {
            _root.interval_time = 0;
            break;
        } 
        case 1:
        {
            _root.interval_time = 32;
            break;
        } 
        case 2:
        {
            _root.interval_time = 16;
            break;
        } 
        case 3:
        {
            _root.interval_time = 8;
            break;
        } 
        case 4:
        {
            _root.interval_time = 4;
            break;
        } 
        case 5:
        {
            _root.interval_time = 2;
            break;
        } 
        default:
        {
            return;
        } 
    } // End of switch
    if (speed)
    {
        speed_str = Math.pow(2, Math.abs(speed) - 1) + "*";
        if (speed < 0)
        {
            speed_str = "-" + speed_str;
        } // end if
    }
    else
    {
        speed_str = "stopped";
    } // end else if
    _root.playspeed = speed;
    _root.speed_tf.text = speed_str;
} // End of the function
function toggle_show_names()
{
    show_names = (show_names + 1) % 3;
} // End of the function
function toggle_show_teams()
{
    team_list_gdi_mc._visible = !team_list_gdi_mc._visible;
    team_list_nod_mc._visible = !team_list_nod_mc._visible;
} // End of the function
function toggle_show_hp()
{
    show_hp = !show_hp;
} // End of the function
function my_init()
{
    mouse_mc.swapDepths(MOUSE_DEPTH);
    about_mc.swapDepths(ABOUT_DEPTH);
    team_list_gdi_mc._visible = false;
    team_list_nod_mc._visible = false;
    time_tf.text = "loading ...";
    speed_tf.text = "--";
    version_tf.text = "V " + VERSION;
    ri = 0;
    last_time = getTimer();
    c4_bt_mc.gotoAndPlay(5);
    _root.c4_tf.textColor = 34816;
} // End of the function
var VERSION = "0.78";
var MOUSE_DEPTH = 200000;
var EXPLOSION_DEPTH = 199960;
var MARKER_DEPTH = 199950;
var ABOUT_DEPTH = 199900;
var SHOT_DEPTH = 199800;
var MINE_DEPTH = 99;
var MAX_EXP_NUM = 30;
attachMovie("mine_machine", "mines_mc", MINE_DEPTH);
attachMovie("shot_machine", "shots_mc", SHOT_DEPTH);
attachMovie("marker_machine", "markers_mc", MARKER_DEPTH);
var objects = new Array();
var players = new Array();
var LOG_BTYPE = new Array();
var LOG_VTYPE = new Array();
var LOG_STYPE = new Array();
var LOG_OTYPE = new Array();
var loaded = false;
var show_names = 0;
var show_teams = false;
var show_hp = false;
var playspeed = 0;
var interval_time = 1000;
var ri = 0;
var us_c = 10000;
var tl_c = 11000;
var oef_counter = -1;
var exp_counter = 0;
var last_log_sec = -1;
var shot_num = 0;
var gamedata = new XML();
var LOG_ACT_CREATED = "C";
var LOG_ACT_POS = "P";
var LOG_ACT_KILLED = "K";
var LOG_ACT_DAMAGED = "A";
var LOG_ACT_DESTROYED = "D";
var LOG_ACT_ENTER = "E";
var LOG_ACT_EXIT = "X";
var LOG_ACT_CHAT = "T";
var LOG_CAT_VEHICLE = "V";
var LOG_CAT_SOLDIER = "S";
var LOG_CAT_BUILDING = "B";
var LOG_CAT_OBJECT = "O";
var LOG_CAT_CRATE = "R";
var LOG_BTYPE_GDI_BARRACKS = "GB";
var LOG_BTYPE_GDI_REF = "GR";
var LOG_BTYPE_GDI_AGT = "GA";
var LOG_BTYPE_GDI_WF = "GW";
var LOG_BTYPE_GDI_PP = "GP";
var LOG_BTYPE_GDI_GUN_CEILING = "GHC";
var LOG_BTYPE_GDI_GUN_AGT = "GHM";
var LOG_BTYPE_NOD_HAND = "NH";
var LOG_BTYPE_NOD_REF = "NR";
var LOG_BTYPE_NOD_OBELISK = "NO";
var LOG_BTYPE_NOD_STRIP = "NA";
var LOG_BTYPE_NOD_PP = "NP";
var LOG_BTYPE_NOD_HELIPAD = "NHP";
var LOG_BTYPE_NOD_SAMSITE = "NSS";
var LOG_BTYPE_NOD_TURRET = "NT";
var LOG_BTYPE_NOD_GUN_TURRET = "NHT";
var LOG_BTYPE_NOD_GUN_TURRETI = "NHI";
var LOG_BTYPE_NOD_GUN_OBELISK = "NHO";
var LOG_VTYPE_GDI_APC = "GA";
var LOG_VTYPE_GDI_HARVY = "GH";
var LOG_VTYPE_GDI_HUMM = "GU";
var LOG_VTYPE_GDI_MAMMOTH = "GMA";
var LOG_VTYPE_GDI_MEDIUM = "GME";
var LOG_VTYPE_GDI_MRLS = "GR";
var LOG_VTYPE_GDI_ORCA = "GO";
var LOG_VTYPE_NOD_APC = "NA";
var LOG_VTYPE_NOD_ARTI = "NM";
var LOG_VTYPE_NOD_BUGGY = "NB";
var LOG_VTYPE_NOD_FLAME = "NF";
var LOG_VTYPE_NOD_HARVY = "NH";
var LOG_VTYPE_NOD_LIGHT = "NL";
var LOG_VTYPE_NOD_STEALTH = "NS";
var LOG_VTYPE_NOD_APACHE = "NAP";
var LOG_STYPE_GDI_MINIGUNNER = "GM";
var LOG_STYPE_GDI_SHOTGUNNER = "GS";
var LOG_STYPE_GDI_GRENADIER = "GG";
var LOG_STYPE_GDI_ENGINEER = "GE";
var LOG_STYPE_GDI_OFFICER = "GO";
var LOG_STYPE_GDI_ROCKET_SOLDIER = "GR";
var LOG_STYPE_GDI_SYDNEY = "GSY";
var LOG_STYPE_GDI_DEADEYE = "GDE";
var LOG_STYPE_GDI_GUNNER = "GGU";
var LOG_STYPE_GDI_PATCH = "GPA";
var LOG_STYPE_GDI_HAVOC = "GHA";
var LOG_STYPE_GDI_PROTO_SYDNEY = "GPS";
var LOG_STYPE_GDI_MOBIUS = "GMO";
var LOG_STYPE_GDI_HOTWIRE = "GH";
var LOG_STYPE_NOD_MINIGUNNER = "NG";
var LOG_STYPE_NOD_SHOTGUNNER = "NS";
var LOG_STYPE_NOD_FLAMETHROWER = "NF";
var LOG_STYPE_NOD_ENGINEER = "NE";
var LOG_STYPE_NOD_OFFICER = "NO";
var LOG_STYPE_NOD_ROCKET_SOLDIER = "NR";
var LOG_STYPE_NOD_CHEM_WARRIOR = "NC";
var LOG_STYPE_NOD_BLACKHAND_SNIPER = "NBS";
var LOG_STYPE_NOD_LASER_CHAINGUNNER = "NLC";
var LOG_STYPE_NOD_SBH = "NSB";
var LOG_STYPE_NOD_SAKURA = "NSA";
var LOG_STYPE_NOD_RAVESHAW = "NRA";
var LOG_STYPE_NOD_MENDOZA = "NME";
var LOG_STYPE_NOD_TECHNICAN = "NT";
var LOG_OTYPE_TIMED = "T4";
var LOG_OTYPE_REMOTE = "R4";
var LOG_OTYPE_PROXY = "P4";
var LOG_OTYPE_ION = "BI";
var LOG_OTYPE_NUKE = "BN";
gamedata.onData = function (raw_text)
{
    show_time("loading game data");
    var _loc3;
    var _loc7;
    this.rows = raw_text.split("\n");
    this.timeline = new Array();
    this.min_x = 999999999;
    this.min_y = 999999999;
    this.max_x = -999999999;
    this.max_y = -999999999;
    if (this.rows[0].substr(-1) == "\r")
    {
        this.rows[0] = this.rows[0].substr(0, this.rows[0].length - 1);
    } // end if
    row = this.rows[0].split(";");
    this.game_start_time = row[0];
    this.map = row[1];
    this.server = row[2];
    this.logversion = Number(row[3]);
    this.timeline.push(1);
    for (var _loc3 = 1; _loc3 < this.rows.length; ++_loc3)
    {
        if (this.rows[_loc3].substr(-1) == "\r")
        {
            this.rows[_loc3] = this.rows[_loc3].substr(0, this.rows[_loc3].length - 1);
        } // end if
        if (this.rows[_loc3].length < 2)
        {
            this.timeline.push(_loc3 + 1);
            continue;
        } // end if
        row = this.rows[_loc3].split(";");
        action = row[0];
        if (action == LOG_ACT_POS)
        {
            x = Number(row[3]);
            y = Number(row[2]);
            if (x < this.min_x)
            {
                this.min_x = x;
            } // end if
            if (y < this.min_y)
            {
                this.min_y = y;
            } // end if
            if (x > this.max_x)
            {
                this.max_x = x;
            } // end if
            if (y > this.max_y)
            {
                this.max_y = y;
            } // end if
        } // end if
    } // end of for
    this.timeline.push(_loc3);
    this.min_x = Math.floor(this.min_x);
    this.min_y = Math.floor(this.min_y);
    this.max_x = Math.ceil(this.max_x);
    this.max_y = Math.ceil(this.max_y);
    this.xo = 0;
    this.yo = 0;
    if (_root.replayfile)
    {
        logs_mc.add_log_line(-1, "file: " + _root.replayfile + "\n");
        logs_mc.add_log_line(-1, "map: " + this.map + "\n");
        logs_mc.add_log_line(-1, "server: " + this.server + "\n");
        logs_mc.add_log_line(-1, "log version: " + this.logversion + "\n");
        logs_mc.add_log_line(-1, "min=(" + this.min_x + ", " + this.min_y + ")\n");
        logs_mc.add_log_line(-1, "max=(" + this.max_x + ", " + this.max_y + ")\n");
    } // end if
    bg_pic_mc._visible = false;
    if (this.map == "C&C_Canyon.mix")
    {
        this.min_x = -123;
        this.min_y = -175;
        this.scale = 1.750000E+000;
        this.xo = 0;
        this.yo = 7;
        bg_pic_mc.loadMovie("maps/Canyon.swf");
    }
    else if (this.map == "C&C_Complex.mix")
    {
        this.min_x = -130;
        this.min_y = -196;
        this.scale = 1.440000E+000;
        this.xo = -40;
        this.yo = 10;
        bg_pic_mc.loadMovie("maps/Complex.swf");
    }
    else if (this.map == "C&C_Field.mix")
    {
        this.min_x = -193;
        this.min_y = -193;
        this.scale = 1.890000E+000;
        this.xo = 12;
        this.yo = -15;
        bg_pic_mc.loadMovie("maps/Field.swf");
    }
    else if (this.map == "C&C_FieldTS.mix")
    {
        this.min_x = -167;
        this.min_y = -172;
        this.scale = 1.920000E+000;
        this.xo = -40;
        this.yo = 15;
        bg_pic_mc.loadMovie("maps/FieldTS.swf");
    }
    else if (this.map == "C&C_Gobi.mix")
    {
        this.min_x = -144;
        this.min_y = -165;
        this.scale = 2.230000E+000;
        this.xo = -13;
        this.yo = -15;
        bg_pic_mc.loadMovie("maps/Gobi.swf");
    }
    else if (this.map == "C&C_Hourglass.mix")
    {
        this.min_x = -127;
        this.min_y = -233;
        this.scale = 1.180000E+000;
        this.xo = -40;
        this.yo = 25;
        bg_pic_mc.loadMovie("maps/Hourglass.swf");
    }
    else if (this.map == "C&C_Islands.mix")
    {
        this.min_x = -178;
        this.min_y = -258;
        this.scale = 1.540000E+000;
        this.xo = -9;
        this.yo = -8;
        bg_pic_mc.loadMovie("maps/Island.swf");
    }
    else if (this.map == "C&C_Siege.mix")
    {
        this.min_x = -255;
        this.min_y = -119;
        this.scale = 1.320000E+000;
        this.xo = 45;
        this.yo = -20;
        bg_pic_mc.loadMovie("maps/Siege.swf");
    }
    else if (this.map == "C&C_Walls.mix" || this.map == "C&C_Walls_Flying.mix")
    {
        this.min_x = -235;
        this.min_y = -240;
        this.scale = 1.260000E+000;
        this.xo = 48;
        this.yo = -12;
        bg_pic_mc.loadMovie("maps/Walls.swf");
    }
    else if (this.map == "C&C_City.mix" || this.map == "C&C_City_Flying.mix")
    {
        bg_pic_mc.loadMovie("maps/City.swf");
        this.min_x = -148;
        this.min_y = -234;
        this.xo = -5;
        this.yo = 8;
        this.scale = 1.230000E+000;
    }
    else
    {
        this.map = "unknown";
        var _loc4 = this.max_x - this.min_x;
        var _loc5 = this.max_y - this.min_y;
        this.xo = 0;
        this.yo = 0;
        if (_loc4 > _loc5)
        {
            this.scale = 600 / _loc4;
        }
        else
        {
            this.scale = 600 / _loc5;
        } // end else if
        this.scale = this.scale * 9.500000E-001;
        bg_pic_mc.loadMovie("maps/unknown.swf");
    } // end else if
};
gamedata.prepare = function ()
{
    show_time("parsing 1");
    x_trans = 600 + this.xo - (600 - _root.bg_pic_mc._width) / 2;
    y_trans = this.yo + (600 - _root.bg_pic_mc._height) / 2;
    for (i = 0; i < this.timeline.length - 1; i++)
    {
        for (j = this.timeline[i]; j < this.timeline[i + 1]; j++)
        {
            row = this.rows[j].split(";");
            action = row[0];
            if (action == LOG_ACT_POS)
            {
                row[3] = x_trans - (Number(row[3]) - this.min_x) * this.scale;
                row[2] = y_trans + (Number(row[2]) - this.min_y) * this.scale;
            }
            else if (action == LOG_ACT_CREATED)
            {
                row[5] = x_trans - (Number(row[5]) - this.min_x) * this.scale;
                row[4] = y_trans + (Number(row[4]) - this.min_y) * this.scale;
                id = row[1];
                category = row[2];
                type = row[3];
                if (category == LOG_CAT_BUILDING)
                {
                    log_b_info = LOG_BTYPE[type];
                    if (this.map != "unknown")
                    {
                        if (type == LOG_BTYPE_NOD_TURRET || type == LOG_BTYPE_NOD_GUN_TURRET)
                        {
                            tx = Number(row[5]);
                            ty = Number(row[4]);
                            mines_mc.lineStyle(2, 16711935, 100);
                            mines_mc.moveTo(tx, ty);
                            mines_mc.lineTo(tx + 1, ty + 1);
                            d1 = (bg_pic_mc.nod_turret1_mc._x - row[5]) * (bg_pic_mc.nod_turret1_mc._x - row[5]) + (bg_pic_mc.nod_turret1_mc._y - row[4]) * (bg_pic_mc.nod_turret1_mc._y - row[4]);
                            d2 = (bg_pic_mc.nod_turret2_mc._x - row[5]) * (bg_pic_mc.nod_turret2_mc._x - row[5]) + (bg_pic_mc.nod_turret2_mc._y - row[4]) * (bg_pic_mc.nod_turret2_mc._y - row[4]);
                            if (d1 < d2)
                            {
                                obj = bg_pic_mc.nod_turret1_mc;
                            }
                            else
                            {
                                obj = bg_pic_mc.nod_turret2_mc;
                            } // end else if
                        }
                        else
                        {
                            obj = log_b_info[2];
                        } // end else if
                        obj.body_mc._alpha = 0;
                        obj.sel_mc._visible = false;
                        obj.useHandCursor = false;
                        obj.onRelease = function ()
                        {
                            this.sel_mc._visible = !this.sel_mc._visible;
                        };
                        obj.onRollOver = function ()
                        {
                            mouse_mc._visible = true;
                            mouse_mc.gotoAndPlay(2);
                            Mouse.hide();
                        };
                        obj.onRollOut = function ()
                        {
                            mouse_mc.gotoAndPlay(1);
                        };
                    }
                    else
                    {
                        obj = attachMovie("unknown_building", id + "_mc", id);
                        obj._x = row[5];
                        obj._y = row[4];
                        if (log_b_info[0] == "G")
                        {
                            obj.name_tf.textColor = 8947712;
                        }
                        else
                        {
                            obj.name_tf.textColor = 16711680;
                        } // end else if
                        obj.name_tf.text = type;
                        obj._visible = true;
                    } // end else if
                    obj.gdi = log_b_info[0] == "G";
                }
                else if (category == LOG_CAT_SOLDIER)
                {
                    if (objects[id] == undefined)
                    {
                        obj = attachMovie("MovingThing", id + "_mc", id);
                        obj.player_name = row[10];
                        obj._visible = false;
                    }
                    else
                    {
                        obj = objects[id];
                    } // end else if
                    if (type == LOG_STYPE_NOD_SBH)
                    {
                        obj.last_shot = new Array();
                        obj.last_shot.push(_root.ri);
                    } // end if
                    obj.gdi = LOG_STYPE[type][0] == "G";
                }
                else if (category == LOG_CAT_VEHICLE)
                {
                    obj = attachMovie("MovingThing", id + "_mc", id);
                    obj.driver = false;
                    obj.passengers = new Array();
                    if (type == LOG_VTYPE_NOD_STEALTH)
                    {
                        obj.last_shot = new Array();
                    } // end if
                    obj.gdi = LOG_VTYPE[type][0] == "G";
                }
                else if (category == LOG_CAT_OBJECT)
                {
                    if (type == LOG_OTYPE_TIMED || type == LOG_OTYPE_ION || type == LOG_OTYPE_NUKE)
                    {
                        obj = attachMovie("MovingThing", id + "_mc", id);
                    }
                    else
                    {
                        obj = new Object();
                    } // end else if
                    obj.gdi = row[10] == 1;
                }
                else if (category == LOG_CAT_CRATE)
                {
                    obj = new Object();
                } // end else if
                obj.id = id;
                obj.objtype = type;
                obj.category = category;
                obj._visible = category == LOG_CAT_BUILDING;
                obj.fighting = false;
                _root.objects[id] = obj;
            } // end else if
            this.rows[j] = row.toString();
        } // end of for
    } // end of for
    show_time("parsing 2");
    time_tf.text = "00:00:00";
    log_tf.text = log_tf.text + (gamedata.timeline.length + " seconds read.\n\n");
    _root.oef_counter = 0;
    _root.loaded = true;
    set_playspeed(0);
};
onEnterFrame = function ()
{
    if (_root.playspeed == 0)
    {
        return;
    } // end if
    ++oef_counter;
    if (_root.playspeed != 0 && oef_counter >= _root.interval_time)
    {
        oef_counter = 0;
        play_next_sec();
    } // end if
};
mouse_mc._visible = false;
my_init();
if (replayfile == undefined)
{
    replayfile = "logs/fieldts_202z.txt";
} // end if
gamedata.load(replayfile);
