// Action script...

// [Action in Frame 1]
function my_init()
{
    shot_array = new Array(MAX_SHOT_NUM);
    for (i = 0; i < this.MAX_SHOT_NUM; i++)
    {
        shot_array[i] = new Array(5);
        shot_array[i][0] = 0;
    } // end of for
} // End of the function
function show_shot(attacker, victim, damage)
{
    if (_root.playspeed <= 0)
    {
        return;
    } // end if
    if (damage == "-")
    {
        color = 2237183;
    }
    else if (attacker.gdi)
    {
        color = 16776960;
    }
    else
    {
        color = 16711680;
    } // end else if
    for (s = 0; s < MAX_SHOT_NUM; s++)
    {
        if (shot_array[s][0] == 0)
        {
            break;
        } // end if
    } // end of for
    shot_array[s][0] = 5 + Math.floor(Math.random() * 15);
    if (attacker.category == _root.LOG_CAT_SOLDIER && attacker.vehicle != false)
    {
        attacker = attacker.vehicle;
    } // end if
    shot_array[s][1] = attacker;
    shot_array[s][2] = victim;
    shot_array[s][3] = color;
    shot_array[s][4] = damage;
    attacker.fighting = attacker.fighting + 1;
    victim.fighting = victim.fighting + 1;
    if (attacker.category == _root.LOG_CAT_SOLDIER)
    {
        if (attacker.vehicle)
        {
            if (attacker.vehicle.objtype == _root.LOG_VTYPE_NOD_STEALTH)
            {
                attacker.vehicle.last_shot.push(_root.ri);
            } // end if
        }
        else if (attacker.objtype == _root.LOG_STYPE_NOD_SBH)
        {
            attacker.last_shot.push(_root.ri);
        } // end if
    } // end else if
} // End of the function
var MAX_SHOT_NUM = 64;
var shot_array;
onEnterFrame = function ()
{
    if (_root.playspeed == 0)
    {
        return;
    } // end if
    clear();
    shot_time = Math.ceil(_root.interval_time / 4);
    for (i = 0; i < this.MAX_SHOT_NUM; i++)
    {
        if (this.shot_array[i][0] > 0)
        {
            if (this.shot_array[i][0] <= shot_time)
            {
                attacker = this.shot_array[i][1];
                victim = this.shot_array[i][2];
                lineStyle(1, shot_array[i][3], 100);
                this.moveTo(attacker._x, attacker._y);
                if (victim.category == _root.LOG_CAT_BUILDING)
                {
                    this.lineTo(victim._x + victim._width / 2, victim._y + victim._height / 2);
                }
                else
                {
                    this.lineTo(victim._x, victim._y);
                } // end if
            } // end else if
            --this.shot_array[i][0];
            if (this.shot_array[i][0] == 0)
            {
                shot_array[i][1].fighting = shot_array[i][1].fighting - 1;
                shot_array[i][2].fighting = shot_array[i][2].fighting - 1;
            } // end if
        } // end if
    } // end of for
};
my_init();
